/***************************************************************************
                          binaryc.cpp  -  description
                             -------------------
    begin                : Tue Dec 28 1999
    copyright            : (C) 1999 by Philipp Ghring
    email                : p.guehring@poboxes.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "stdafx.h"

#include "transc.h"
#include <ctype.h>

#include "binaryc.h"

#include "outputc.h"


BinaryC::BinaryC(const char *Directory,const char *Filename,unsigned char Wert)
{
  QString Name(Directory);
  Handle=NULL;N=0;Muster=Wert;
  Dateiname=Filename;
  Name+=Filename;
  #ifdef DEB
    printf("BinFile: %s\n",(const char *)Name);
  #endif
  Handle=fopen(Name,FILE_READ_BINARY);
  if (Handle!=NULL)
  {
    fseek(Handle,0,SEEK_END);
    N=ftell(Handle);
  }
  else
    printf("Could not open file!\n");
}


BinaryC::~BinaryC()
{
  fclose(Handle);
}

long BinaryC::get(const char *v)
{
  long l=0, r=N, x,xr,xl;
  char ch;
  const char *a;
  if (v==NULL) return -1; //Nothing found
  while((l+2)<r)
  {
    x=(l+r)/2;xr=x;
    fseek(Handle,x,SEEK_SET);
    ch=fgetc(Handle);
#ifdef __unix__
    while(ch!='\n' && x>0)
    {
      x--;
      fseek(Handle,x,SEEK_SET);
      ch=fgetc(Handle);
    };
#else
    while(ch!='\n' && x<r)
    {
      x++;
      ch=fgetc(Handle);
    };
#endif
    xl=x;
    if(x)
    {
      ch=fgetc(Handle);
    }
    for(a=v;tolower(*a)==tolower(ch) && !feof(Handle);a++)
    {
      ch=fgetc(Handle);
    }
    if(!*a && ch=='\t') return ftell(Handle);
    if(tolower(*a)<tolower(ch)) r=xl-1;
    if(tolower(*a)>tolower(ch)) l=xr+1;
  };
  return (-1);
}

int BinaryC::search(const char *p_word,OutputC *html, int style)
{
  QString line;
  long Pos;
  char ch;
  if(p_word==NULL) return 0;
  Pos = get( p_word );
  #ifdef DEB
    printf("BinQuery(%s): %s %ld\n",Dateiname,p_word,Pos);
  #endif
  if (Pos>-1)
  {
    switch(style)
    {
      case 0:
        line.Format( i18n("%s%s translation of %s: %s"),"" , (const char*)Dateiname, p_word, "<font size=\"+1\">" );
      break;
      case 1:
        line.Format( i18n("%s%s translation of %s: %s"),"" , (const char*)Dateiname, p_word, "" );
      break;
      case 2:
        line.Format("%s", p_word );
      break;
    }

    ch=fgetc(Handle)^Muster;
    while(ch!='\n' && !feof(Handle))
    {
      line+=ch;
      ch=fgetc(Handle)^Muster;
    }
    line+=(style==0)?"</font><br/>\n":"\n";
    html->write(line);
    return 1;
  }
  return 0;
}
